----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------Changelog----------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----	Version Beta 1.0.2		Added a select menu  to "add to auto-vendor", allowing the user to add items to the "auto-vendor table" by picking from a dropdown, showing		----
----								items in their inventory.																																						----
----																																																					----
----	Version Beta 1.0.1		Added option to auto-sell costumized items when visitting a vendor.																									----
----																																																					----
----	Version Beta 1.0.0		Added option to hide minimap button.																																		----
----								Added option to completely enable/disable the autolooting part of addon (ignoring other settings).															----
----								Fixed bug causing addon not to work for some classes.																													----
----																																																					----
----	Version Alpha 1.0.4	Added minimap button.																																						----
----								Fixed the auto repair not accepting nil when asking for guild funds.																									----
----								Auto repair and junk seller now reporting price/profit.																													----
----								Fixed a bug, causing necks, rings and trinkets to be passed.																											----
----																																																					----
----	Version Alpha 1.0.3	Added auto-repair and auto "vendor grey" along with options to this.																								----
----																																																					----
----	Version Alpha 1.0.2:	Added extra options to auto-loot all items below certain item level.																									----
----								Added options to disenchant/greed loot instead of just passing.																										----
----								Added an option to mute the addon.																																		----
----																																																					----
----	Version Alpha 1.0.1:	Added profiles and a couple of options to expand on. In addition, slash commands ({"lp", "lootpasser"}) has been added.									----
----																																																					----
----	Version Alpha 1.0.0: 	Released Alpha (No options, no costumization)																															----
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
LootPasser = LibStub("AceAddon-3.0"):NewAddon("LootPasser", "AceConsole-3.0", "AceEvent-3.0")

-- Colored chat prefix (  <LootPasser>  )
local chatPrefix = "|cffff7d0a<|r|cff1784d1LootPasser|r|cffff7d0a>|r"

-- Set and get functions
local function createSetter(option)
	return function(info, value)
		LootPasser.db.profile[option] = value
		if option == "minimapButton" then
			print(chatPrefix.. "Reload required!")
		end
	end
end
local function createGetter(option)
	return function(info)
		return LootPasser.db.profile[option]
	end
end

-- Class loot groups
local LootPasser_LootGroup = {
	MAGE = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Leather",
		[4] = "Shields",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Fist Weapons",
		[8] = "One-Handed Axes",
		[9] = "One-Handed Maces",
		[10] = "Polearms",
		[11] = "Thrown",
		[12] = "Two-Handed Axes",
		[13] = "Two-Handed Maces",
		[14] = "Two-Handed Swords",
		[15] = "Guns",
	},
	WARLOCK = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Leather",
		[4] = "Shields",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Fist Weapons",
		[8] = "One-Handed Axes",
		[9] = "One-Handed Maces",
		[10] = "Polearms",
		[11] = "Thrown",
		[12] = "Two-Handed Axes",
		[13] = "Two-Handed Maces",
		[14] = "Two-Handed Swords",
		[15] = "Guns",
	},
	PRIEST = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Leather",
		[4] = "Shields",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Fishing Poles",
		[8] = "Fist Weapons",
		[9] = "One-Handed Axes",
		[10] = "One-Handed Swords",
		[11] = "Polearms",
		[12] = "Thrown",
		[13] = "Two-Handed Axes",
		[14] = "Two-Handed Maces",
		[15] = "Two-Handed Swords",
		[16] = "Guns",
	},
	ROGUE = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Shields",
		[4] = "Cloth",
		[5] = "Held in Off-hands",
		--WeaponTypes
		[6] = "Bows",
		[7] = "Crossbows",
		[8] = "Polearms",
		[9] = "Staves",
		[10] = "Thrown",
		[11] = "Two-Handed Axes",
		[12] = "Two-Handed Maces",
		[13] = "Two-Handed Swords",
		[14] = "Wands",
		[15] = "Guns",
	},
	MONK = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Shields",
		[4] = "Cloth",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Daggers",
		[8] = "Thrown",
		[9] = "Two-Handed Axes",
		[10] = "Two-Handed Maces",
		[11] = "Two-Handed Swords",
		[12] = "Wands",
		[13] = "Guns",
	},
	DRUID = {
		[1] = "Mail",
		[2] = "Plate",
		[3] = "Shields",
		[4] = "Cloth",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Fist Weapons",
		[8] = "One-Handed Axes",
		[9] = "One-Handed Swords",
		[10] = "Polearms",
		[11] = "Staves",
		[12] = "Thrown",
		[13] = "Two-Handed Axes",
		[14] = "Two-Handed Swords",
		[15] = "Wands",
	},
	HUNTER = {
		[1] = "Plate",
		[2] = "Leather",
		[3] = "Shields",
		[4] = "Cloth",
		[5] = "Held in Off-hands",
		--WeaponTypes
		[6] = "Daggers",
		[7] = "Fist Weapons",
		[8] = "One-Handed Axes",
		[9] = "One-Handed Maces",
		[10] = "One-Handed Swords",
		[11] = "Polearms",
		[12] = "Staves",
		[13] = "Thrown",
		[14] = "Two-Handed Axes",
		[15] = "Two-Handed Maces",
		[16] = "Two-Handed Swords",
		[17] = "Wands",
	},
	SHAMAN = {
		[1] = "Plate",
		[2] = "Leather",
		[3] = "Cloth",
		--WeaponTypes
		[4] = "Bows",
		[5] = "Crossbows",
		[6] = "One-Handed Swords",
		[7] = "Polearms",
		[8] = "Thrown",
		[9] = "Two-Handed Axes",
		[10] = "Two-Handed Maces",
		[11] = "Two-Handed Swords",
		[12] = "Wands",
		[13] = "Guns",
	},
	WARRIOR = {
		[1] = "Leather",
		[2] = "Mail",
		[3] = "Cloth",
		[4] = "Held in Off-hands",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Daggers",
		[8] = "Staves",
		[9] = "Thrown",
		[10] = "Wands",
		[11] = "Guns",
	},
	PALADIN = {
		[1] = "Leather",
		[2] = "Mail",
		[3] = "Cloth",
		[4] = "Held in Off-hands",
		--WeaponTypes
		[5] = "Bows",
		[6] = "Crossbows",
		[7] = "Daggers",
		[8] = "Fist Weapons",
		[9] = "Staves",
		[10] = "Thrown",
		[11] = "Wands",
		[12] = "Guns",
	},
	DEATHKNIGHT = {
		[1] = "Mail",
		[2] = "Leather",
		[3] = "Shields",
		[4] = "Cloth",
		[5] = "Held in Off-hands",
		--WeaponTypes
		[6] = "Bows",
		[7] = "Crossbows",
		[8] = "Daggers",
		[9] = "Fist Weapons",
		[10] = "Staves",
		[11] = "Thrown",
		[12] = "Wands",
		[13] = "Guns",

	},
}

-- Options table
local options = {
	name = "LootPasser",
	type = "group",
	args = {
		gui = {
			name = "Show the GUI",
			type = "execute", 
			func = function()
				LibStub("AceConfigDialog-3.0"):Open("LootPasser")
			end,
			guiHidden = true,
		},
		general = {
			name = "General",
			type = "group",
			handler = LootPasser,
			order = 0,
			args = {
				description = {
					type = "description",
					name = "General: Options to toggle 'Pass/greed/disenchant on loot' and other features.",
					order = 0,
				},
				enable = {
					name = "Enable/Disable",
					type = "toggle",
					desc = "If toggled 'Off', the addon will NOT auto loot any items, dispise settings below!",
					order = 1,
					get = createGetter("enableAutoLoot"),
					set = createSetter("enableAutoLoot"),
				},
				Seperator = {
					type = "description",
					name = " ",
					order = 2,
				},
				weapons = {
					name = "Weapons",
					type = "toggle",
					desc = "Toggles whether or not to autoloot weapons",
					order = 3,
					get = createGetter("Weapon"),
					set = createSetter("Weapon"),
				},
				armor = {
					name = "Armor",
					type = "toggle",
					desc = "Toggles whether or not to autoloot armor",
					order = 3,
					get = createGetter("Armor"),
					set = createSetter("Armor"),
				},
				disenchant3 = {
					name = "Disenchant before passing",
					desc = "Tries to roll 'Disenchant' for all items that would otherwise be passed",
					type = "toggle",
					order = 4, 
					get = createGetter("disenchant3"),
					set = createSetter("disenchant3"),
				},
				disenchant = {
					name = "Disenchant all greens",
					type = "toggle",
					order = 4, 
					desc = "If checked, all green quality items will be rolled as disenchant if possible, otherwise they will be passed/greeded - depending on your selected choice.",
					get = createGetter("disenchant"),
					set = createSetter("disenchant"),
					},
				mute = {
					name = "Mute",
					type = "toggle",
					order = 4, 
					desc = "Mutes LootPasser.",
					get = createGetter("mute"),
					set = createSetter("mute"),
				},	
				iLevel = {
					name = "Item Level",
					desc = "Will pass items below selected item level. 0 will disable this function. If you are typing value, make sure to press enter.",
					type = "range",
					order = 4, 
					min = 0,
					max = 635,
					step = 1,
					get = createGetter("iLevel"),
					set = createSetter("iLevel"),
				},
				greedOrPass = {
					name = "Greed or pass",
					desc = "Choose to either auto greed or pass on loot you can't use or don't need.",
					type = "select",
					order = 4,
					values = {
						greed = "Greed",
						pass = "Pass",
					},
					get = function()
						if LootPasser.db.profile.greedOrPass == 0 then
							return "pass"
						elseif LootPasser.db.profile.greedOrPass == 2 then
							return "greed"
						end
					end,
					set = function(info, value)
						if value == "greed" then
							LootPasser.db.profile.greedOrPass = 2
						elseif value == "pass" then
							LootPasser.db.profile.greedOrPass = 0
						end
					end,
				},
				minimapButton = {
					name = "Hide/show Minimap button",
					type = "toggle",
					desc = "Hides or shows the Minimap button",
					order = 5,
					get = createGetter("minimapButton"),
					set = createSetter("minimapButton"),
				},	
			},
		},
		repairvendor = {
			name = "Repair and vendor",
			type = "group",
			order = 1,
			args = {
				autoRepair = {
					name = "Auto repair",
					desc = "Toggle automatic repair when visitting a vendor with repair.",
					type = "toggle",
					order = 1,
					get = createGetter("autoRepair"),
					set = createSetter("autoRepair"),
				},
				guildRepair = {
					name = "Guild repair",
					desc = "automatically repairs for guild money if available.",
					type = "toggle",
					order = 1,
					get = createGetter("guildRepair"),
					set = createSetter("guildRepair"),
				},
				vendorGrey = {
					name = "Vendor greys",
					desc = "Automatically sells all grey items when visitting a vendor.",
					type = "toggle",
					order = 1,
					get = createGetter("vendorGrey"),
					set = createSetter("vendorGrey"),
				},
				Seperator = {
					type = "description",
					name = "Toggle costum sell list.",
					order = 2,
				},
				Description1 = {
					type = "description",
					name = "Add items to be autosold below by either putting item link, or by choosing items from your inventory in the dropdown.",
					order = 3,
				},
				autosellitemAdd = {
					type = "input";
					name = "Auto sell item [itemLink]";
					order = 4,
					desc = "Put in item link and press 'ENTER' to autosell all of this item next time you visit vendor. Only one item per entry.";
					usage = "ItemLink";
					set = function (info, value)
						table.insert(LootPasser.db.profile.userDefinedSell, 1, 0)
						LootPasser.db.profile.userDefinedSell[1] = value
						updateRemoveTable()
					end;
				},
				autosellitemAdd1 = {
					name = "Auto sell item [Select]",
					desc = "Choose which items to be removed from the list of auto-vendored items.",
					type = "select",
					order = 4,
					values = {},
					set = function(info, value)
						updateAddTable(value)
						updateRemoveTable()
					end
				},				
				Description2 = {
					type = "description",
					name = "Remove items from the list of 'autosold' items in the select below, or reset the list by pressing 'Reset'.",
					order = 5,
				},
				autosellitemRemove = {
					name = "Remove auto-vendored items",
					desc = "Choose which items to be removed from the list of auto-vendored items.",
					type = "select",
					order = 6,
					values = {},
					set = function(info, value)
						LootPasser.db.profile.userDefinedSell[value] = nil
						updateRemoveTable()
					end
				},				
				resetCostumItemTable = {
					name = "Reset",
					desc = "Resets the user-defined auto-sell list.",
					order = 7,
					type = "execute", 
					func = function()
						table.wipe(LootPasser.db.profile.userDefinedSell)
						updateAddTable()
						print(chatPrefix.. "|cFFFFFF66All user defined auto-sell items have been wiped, and will no longer be sold automatically.")
					end,
				},
			},
		},
	},
}

-- Default settings (Only loaded if no profile is selected or when profile is reset(there's no saved variable))
local defaults = {
	profile = {
		Weapon = true,
		Armor = true,
		iLevel = 0,
		disenchant3 = false,
		disenchant = false,
		greedOrPass = 2,
		mute = false,
		autoRepair = true,
		guildRepair = true,
		vendorGrey = true,
		minimapButton = true,
		enableAutoLoot = true,
		userDefinedSell = {},
	},
}

-- Function to update the table for which items to be autovendored.
function updateRemoveTable()
	options.args.repairvendor.args.autosellitemRemove.values = LootPasser.db.profile.userDefinedSell
end
function updateAddTable(value)
	if value then
		table.insert(LootPasser.db.profile.userDefinedSell, 1, 0)
		LootPasser.db.profile.userDefinedSell[1] = options.args.repairvendor.args.autosellitemAdd1.values[value]
		options.args.repairvendor.args.autosellitemAdd1.values[value] = nil
	end
	for bag = 0,4,1 do
		for slot = 1, GetContainerNumSlots(bag), 1 do
			local name = GetContainerItemLink(bag,slot)
			if name then
				table.insert(options.args.repairvendor.args.autosellitemAdd1.values , 1, 0)
				options.args.repairvendor.args.autosellitemAdd1.values[1] = name
			end
			for i = 1, 200 do
				if options.args.repairvendor.args.autosellitemAdd1.values[1] and options.args.repairvendor.args.autosellitemAdd1.values[1] == LootPasser.db.profile.userDefinedSell[i] then
					options.args.repairvendor.args.autosellitemAdd1.values[1] = nil
				end
			end
			for i = 2, 200 do
				if options.args.repairvendor.args.autosellitemAdd1.values[1] and options.args.repairvendor.args.autosellitemAdd1.values[1] == options.args.repairvendor.args.autosellitemAdd1.values[i] then
					options.args.repairvendor.args.autosellitemAdd1.values[1] = nil
				end
			end
		end
	end
end

-- Table of itemtypes to deal with.
local lootTypes = {
	Weapon = true,
	Armor = true,
}

-- OnInitialize function (sets the saved variables, and the GUIs)
function LootPasser:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("LootPasserDB", defaults)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("LootPasser", options,{"lootpasser", "lp"})
	LibStub("AceConfig-3.0"):RegisterOptionsTable("General", options.args.general)
	self.db.RegisterCallback(self, "OnProfileCopied", "RefreshConfig")
	options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfig-3.0"):RegisterOptionsTable("Profiles", options.args.profiles)
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("General", "Loot Passer")
	self.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("Profiles", "Profiles", "Loot Passer")
	
	
	--Minimap button
	if self.db.profile.minimapButton then
		LootPasserIcon = LibStub("LibDataBroker-1.1", true) and LibStub("LibDBIcon-1.0", true)
		local LootPasserLauncher = LibStub("LibDataBroker-1.1", true):NewDataObject("LootPasserMinimapIcon", {
			icon = "Interface\\ICONS\\ability_deathknight_sanguinfortitude",
			OnClick = function(_, button) -- fires when a user clicks on the minimap icon
				if button == "LeftButton" then
					-- does the same thing as typing '/lp gui'
					LibStub("AceConfigDialog-3.0"):Open("LootPasser");
				end
			end,
			OnTooltipShow = function(tt) -- tooltip that shows when you hover over the minimap icon
				tt:AddLine("|cffff7d0a<|r|cff1784d1LootPasser|r|cffff7d0a>|r")
				tt:AddLine("|c00ffff99Click |c00ffff33to open config")
				tt:AddLine("|c00ffff99Drag |c00ffff33to move")
			end,
		})
		LootPasserIcon:Register("LootPasser", LootPasserLauncher, LootPasser.db.profile.minimap)
		local LootPasserLauncher2 = LibStub("LibDataBroker-1.1", true):NewDataObject("TradeSkillMaster", {
			type = "launcher",
			icon = "Interface\\ICONS\\ability_deathknight_sanguinfortitude",
			OnClick = function(_, button) -- fires when a user clicks on the minimap icon
				if button == "LeftButton" then
					-- does the same thing as typing '/lp gui'
					LibStub("AceConfigDialog-3.0"):Open("LootPasser");
				end
			end,
			OnTooltipShow = function(tt) -- tooltip that shows when you hover over the minimap icon
				tt:AddLine("|cffff7d0a<|r|cff1784d1LootPasser|r|cffff7d0a>|r")
				tt:AddLine("|c00ffff99Click |c00ffff66to open config")
				tt:AddLine("|c00ffff99Drag |c00ffff66to move")
			end,
		})
	end
	
end

--  OnEnable function (Registers events and fires warning)
function LootPasser:OnEnable()
	self:RegisterEvent("START_LOOT_ROLL")
	self:RegisterEvent("MERCHANT_SHOW")
	self:RegisterEvent("MERCHANT_CLOSED")
	self:RegisterEvent("PLAYER_LEVEL_UP")
	print(chatPrefix.." |cffffff00is enabled! |cffffff00Be aware, that items you cannot equip will be passed!")
	if not LootPasser.db.profile.minimapButton then
		print(chatPrefix.." |c000fffffFor a list of valid /slash commands, type '/lp' or '/lootpasser'.")							--Unneccesary as of version 6.1.2:0002 with the implemention of Minimap icon. Will be re-implemented next version with the implementation of a "Toggle minimap button".
	end
	if select(2, UnitClass("PLAYER")) == "SHAMAN" or select(2, UnitClass("PLAYER")) == "HUNTER"  or select(2, UnitClass("PLAYER")) == "WARRIOR" or select(2, UnitClass("PLAYER")) == "PALADIN" then
		local class = select(2, UnitClass("PLAYER"))
		if UnitLevel("PLAYER") <= 39 then
			local passItemType
			local rollItemType
			if class == "WARRIOR" or class == "PALADIN" then 
				passItemType = "plate"
				rollItemType = "mail"	
			else
				passItemType = "mail"
				rollItemType = "plate"	
			end
			print(chatPrefix .. " |cFFFFFF66You are below level 40, therefor, if toggled, "..passItemType.." will be auto distributed instead of "..rollItemType..".")
			LootPasser_LootGroup.SHAMAN[2] = "Mail"
			LootPasser_LootGroup.HUNTER[2] = "Mail"
			LootPasser_LootGroup.PALADIN[2] = "Plate"
			LootPasser_LootGroup.WARRIOR[2] = "Plate"
		end
	end
	updateRemoveTable()
	updateAddTable()
end

-- OnDisable function (No functionality as of now)
function LootPasser:OnDisable()
--
end

-- Function to set lootSubType for palas, shamans, warriors, hunters upon reaching level 40.
function LootPasser:PLAYER_LEVEL_UP(...)
	local levelReached = select(1, ...)
	local passItemType
	local rollItemType
	if levelReached ~= 40 then
		print(chatPrefix.." |cFFFFFF66Congratulations on reaching level "..levelReached..", "..UnitName("PLAYER")"!")
	else
		if class == "WARRIOR" or class == "PALADIN" then 
			passItemType = "mail"
			rollItemType = "plate"	
		else
			passItemType = "plate"
			rollItemType = "mail"	
		end
		if levelReached == 40 then
			LootPasser_LootGroup.SHAMAN[2] = "Leather"
			LootPasser_LootGroup.HUNTER[2] = "Leather"
			LootPasser_LootGroup.WARRIOR[2] = "Plate"
			LootPasser_LootGroup.PALADIN[2] = "Plate"
			print(chatPrefix .. " |cFFFFFF66You've reached level 40! Congratulations! LootPasser will now be auto distributing passing/greeding "..passItemType.." and allow you to roll for "..rollItemType.."!")
		end
	end
end

-- OnEvent handler(START_LOOT_ROLL) collects the RollId and calls for "getItemInfo" function. Also checks if "enableAutoLoot" is toggled.
function LootPasser:START_LOOT_ROLL(...)
	-- Checks if auto loot is toggled on or off.
	if LootPasser.db.profile.enableAutoLoot then
		local rollID = select(2, ...)
		getItemInfo(rollID)
	end		
end

-- Gets the item information and players class and calls for "lootPasser" function.
function getItemInfo(rollID)
	local itemName = GetLootRollItemLink(rollID)
	local _, _, itemQuality, itemLevel, _, lootType, lootSubType, _, equipSlot, texture = GetItemInfo(itemName)
	local class = select(2, UnitClass("PLAYER")) 
	lootPasser(rollID, itemName, lootType, lootSubType, class, texture, itemLevel, equipSlot, itemQuality)
end

-- Main function of addon - this function deals with the loot.
function lootPasser(rollID, itemName, lootType, lootSubType, class, texture, itemLevel, equipSlot, itemQuality)
	local greedOrPass = LootPasser.db.profile.greedOrPass
	--this part sets the printed message to "greeded" or "passed" depending on which option is selected.
	local lootMethodInput	
	if greedOrPass == 0 then
		lootMethodInput = "passed"
	else
		lootMethodInput = "greeded"
	end
	--Main functionallity. This distributes the loot.	
	-- This bit fires if user selected "disenchant all greens".
	if lootTypes[lootType] and LootPasser.db.profile.disenchant and itemQuality == 2 then
		if not LootPasser.db.profile.mute then
			print(chatPrefix.."|cffffd200 Attempted to roll disenchant for "..itemName)
		end
		RollOnLoot(rollID, 3)
		RollOnLoot(rollID, greedOrPass)
		
	-- This bit fires if looted items itemlevel is lower then the preset.
	elseif LootPasser.db.profile[lootType] and LootPasser.db.profile.iLevel and itemLevel <= LootPasser.db.profile.iLevel then
		-- If "disenchant before passing"
		if LootPasser.db.profile.disenchant3 then
			if not LootPasser.db.profile.mute then
				print(chatPrefix.."|cffffd200Item: "..itemName.."|cffffd200 is itemlevel "..itemLevel..", and is attempted disenchanted.")
			end
			RollOnLoot(rollID, 3)
			RollOnLoot(rollID, greedOrPass)		
		-- If not "disenchant before passing"
		else
			if not LootPasser.db.profile.mute then
				print(chatPrefix.."|cffffd200Item: "..itemName.."|cffffd200 is itemlevel "..itemLevel..", and have been "..lootMethodInput..".")
			end
			RollOnLoot(rollID, greedOrPass)
		end
		
	-- This bit fires if a player is unable to use the item
	else
		if LootPasser_LootGroup[class] then
			for i = 1, table.getn(LootPasser_LootGroup[class]) do
		--	print("Doing 'i' for class table")
				-- If item is not usable by you
				if lootSubType == LootPasser_LootGroup[class][i] then
					-- If itemtype is not toggled off
					if LootPasser.db.profile[lootType] then
						-- If "disenchant before passing" - tries to roll disenchant instead of passing the item.
						if LootPasser.db.profile.disenchant3 then
							if not LootPasser.db.profile.mute then
								print(chatPrefix.."|cffffd200Item: "..itemName.."|cffffd200 is unusable for you, and is attempted disenchanted.")
							end
							RollOnLoot(rollID, 3)
							RollOnLoot(rollID, greedOrPass)
						-- If not, then just passing the item.
						else
							if not LootPasser.db.profile.mute then
								print(chatPrefix.."|cffffd200Item: "..itemName.."|cffffd200 is unusable for you, and have been "..lootMethodInput..".")
							end
							RollOnLoot(rollID, greedOrPass)
						end
					end
				end
			end
		end
	end
end

-- This function displays a message when users profile is copied.
function LootPasser:RefreshConfig(self, ...)
	local sourceProfile = select(2, ...)
	print(chatPrefix.." |cffffff00Profile copied - new profile: |cff00ff00".. sourceProfile)
end

-- These functions auto sells and repairs when visitting a vendor.
local sellValue
function LootPasser:MERCHANT_SHOW(...)
	sellValue = 0
	if CanMerchantRepair() then
		local cost = GetRepairAllCost()
		if LootPasser.db.profile.autoRepair then
			local gold, silver, copper = LootPasser:ReturnMoney(cost)
			if cost == 0 then
				if not LootPasser.db.profile.mute then
					print(chatPrefix.."|cFFFFFF66 Your items are already fully repaired!")
				end
			elseif LootPasser.db.profile.guildRepair and IsInGuild() and GetGuildBankWithdrawMoney() >= cost then
				RepairAllItems(1)
				if not LootPasser.db.profile.mute then
					print(chatPrefix.."|cFFFFFF66 Guild payed for repairs! Total cost: |cFFFFFF66" .. gold .. "|cFFFFFF00g |cFFFFFF66" .. silver .. "|cFFAAAAAAs |cFFFFFF66" .. copper .. "|cffcc6600c")
				end
			elseif GetMoney() >= cost then
				RepairAllItems()
				if not LootPasser.db.profile.mute then
					print(chatPrefix.."|cFFFFFF66 Your items have been repaired! Total cost: |cFFFFFF66" .. gold .. "|cFFFFFF00g |cFFFFFF66" .. silver .. "|cFFAAAAAAs |cFFFFFF66" .. copper .. "|cffcc6600c")
				end
			else
				if not LootPasser.db.profile.mute then
					print(chatPrefix.."|cFFFF0000 Not enough money! Total cost: |cFFFFFF66" .. gold .. "|cFFFFFF00g |cFFFFFF66" .. silver .. "|cFFAAAAAAs |cFFFFFF66" .. copper .. "|cFFcc6600c")
				end
			end
		end
	end
	if LootPasser.db.profile.vendorGrey then
		for bag = 0,4,1 do
			for slot = 1, GetContainerNumSlots(bag), 1 do
				local name = GetContainerItemLink(bag,slot)
				if name and string.find(name,"ff9d9d9d") then
					UseContainerItem(bag,slot)
					sellValue = sellValue + select(11, GetItemInfo(name))
				end
				for i = 1, 200 do
					for v = 1, 200 do
						if name and name == LootPasser.db.profile.userDefinedSell[i] then
							UseContainerItem(bag,slot)
							sellValue = sellValue + select(11, GetItemInfo(name))
						end
					end
				end
			end
		end
	end
end
function LootPasser:MERCHANT_CLOSED()
	if sellValue ~= 0 then
		local gold, silver, copper = LootPasser:ReturnMoney(sellValue)
		if not LootPasser.db.profile.mute then
			print(chatPrefix.."|cFFFFFF66 You sold junk for a total of: |cFFFFFF66" .. gold .. "|cFFFFFF00g |cFFFFFF66" .. silver .. "|cFFAAAAAAs |cFFFFFF66" .. copper .. "|cffcc6600c")
		end
		sellValue = 0
	end
end

-- ReturnMoney
function LootPasser:ReturnMoney(money)
	local absMoney = abs(money)
	local gold = floor (absMoney / 10000)
	local silver = floor ((absMoney - gold*10000) / 100)
	local copper = absMoney - gold*10000 - silver*100
	return gold, silver, copper
end
